#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var minimist_1 = __importDefault(require("minimist"));
//import help from 'help.md';
var help = 'See /usr/share/doc/rollup/help.md or man rollup';
//import { version } from 'package.json';
var version = '0.56.3';
var index_1 = __importDefault(require("./run/index"));
var command = minimist_1.default(process.argv.slice(2), {
    alias: {
        // Aliases
        strict: 'useStrict',
        dir: 'output.dir',
        // Short options
        c: 'config',
        d: 'indent',
        e: 'external',
        f: 'output.format',
        g: 'globals',
        h: 'help',
        i: 'input',
        l: 'legacy',
        m: 'sourcemap',
        n: 'name',
        o: 'output.file',
        v: 'version',
        w: 'watch'
    }
});
if (command.help || (process.argv.length <= 2 && process.stdin.isTTY)) {
    console.log("\n" + help.replace('__VERSION__', version) + "\n"); // eslint-disable-line no-console
}
else if (command.version) {
    console.log("rollup version " + version); // eslint-disable-line no-console
}
else {
    try {
        require('source-map-support').install();
    }
    catch (err) {
        // do nothing
    }
    index_1.default(command);
}
