"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var FunctionNode_1 = __importDefault(require("./shared/FunctionNode"));
var Scope_1 = __importDefault(require("../scopes/Scope"));
function isFunctionDeclaration(node) {
    return node.type === "FunctionDeclaration" /* FunctionDeclaration */;
}
exports.isFunctionDeclaration = isFunctionDeclaration;
var FunctionDeclaration = /** @class */ (function (_super) {
    __extends(FunctionDeclaration, _super);
    function FunctionDeclaration() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FunctionDeclaration.prototype.initialiseChildren = function (parentScope) {
        var _this = this;
        if (this.id !== null) {
            this.id.initialiseAndDeclare(parentScope, 'function', this);
            this.id.variable.isId = true;
        }
        this.params.forEach(function (param) {
            return param.initialiseAndDeclare(_this.scope, 'parameter', null);
        });
        this.body.initialiseAndReplaceScope(new Scope_1.default({ parent: this.scope }));
    };
    return FunctionDeclaration;
}(FunctionNode_1.default));
exports.default = FunctionDeclaration;
