"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var Node_1 = require("./shared/Node");
var NamespaceVariable_1 = __importDefault(require("../variables/NamespaceVariable"));
var Import = /** @class */ (function (_super) {
    __extends(Import, _super);
    function Import() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Import.prototype.setResolution = function (resolution, interop) {
        this.resolution = resolution;
        this.resolutionInterop = interop;
    };
    Import.prototype.render = function (code, options) {
        // if we have the module in the chunk, inline as Promise.resolve(namespace)
        if (this.resolution instanceof NamespaceVariable_1.default) {
            // ideally this should be handled like normal tree shaking
            this.resolution.includeVariable();
            code.overwrite(this.parent.start, this.parent.arguments[0].start, 'Promise.resolve().then(function () { return ');
            code.overwrite(this.parent.arguments[0].start, this.parent.arguments[0].end, this.resolution.getName());
            code.overwrite(this.parent.arguments[0].end, this.parent.end, '; })');
        }
        else {
            if (options.importMechanism) {
                var leftMechanism = this.resolutionInterop && options.importMechanism.interopLeft || options.importMechanism.left;
                code.overwrite(this.parent.start, this.parent.arguments[0].start, leftMechanism);
            }
            if (this.resolution) {
                code.overwrite(this.parent.arguments[0].start, this.parent.arguments[0].end, this.resolution);
            }
            if (options.importMechanism) {
                var rightMechanism = this.resolutionInterop && options.importMechanism.interopRight || options.importMechanism.right;
                code.overwrite(this.parent.arguments[0].end, this.parent.end, rightMechanism);
            }
        }
    };
    return Import;
}(Node_1.NodeBase));
exports.default = Import;
