"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getExportBlock(exports, dependencies, exportMode, mechanism) {
    if (mechanism === void 0) { mechanism = 'return'; }
    if (exportMode === 'default') {
        var local_1;
        exports.some(function (expt) {
            if (expt.exported === 'default') {
                local_1 = expt.local;
                return true;
            }
            return false;
        });
        // search for reexported default otherwise
        if (!local_1) {
            dependencies.some(function (dep) {
                if (!dep.reexports)
                    return false;
                return dep.reexports.some(function (expt) {
                    if (expt.reexported === 'default') {
                        local_1 = dep.name + "." + expt.imported;
                        return true;
                    }
                    return false;
                });
            });
        }
        return mechanism + " " + local_1 + ";";
    }
    var exportBlock = '';
    // star exports must always output first for precedence
    dependencies.forEach(function (_a) {
        var name = _a.name, reexports = _a.reexports;
        if (reexports && exportMode !== 'default') {
            reexports.forEach(function (specifier) {
                if (specifier.reexported === '*') {
                    exportBlock += (exportBlock ? '\n' : '') + "Object.keys(" + name + ").forEach(function (key) { exports[key] = " + name + "[key]; });";
                }
            });
        }
    });
    dependencies.forEach(function (_a) {
        var name = _a.name, imports = _a.imports, reexports = _a.reexports, isChunk = _a.isChunk;
        if (reexports && exportMode !== 'default') {
            reexports.forEach(function (specifier) {
                if (specifier.imported === 'default' && !isChunk) {
                    var exportsNamesOrNamespace = imports &&
                        imports.some(function (specifier) { return specifier.imported === '*' || specifier.imported !== 'default'; }) ||
                        reexports && reexports.some(function (specifier) { return specifier.imported !== 'default' && specifier.imported !== '*'; });
                    if (exportsNamesOrNamespace) {
                        exportBlock += (exportBlock ? '\n' : '') + "exports." + specifier.reexported + " = " + name + "__default;";
                    }
                    else {
                        exportBlock += (exportBlock ? '\n' : '') + "exports." + specifier.reexported + " = " + name + ";";
                    }
                }
                else if (specifier.imported !== '*') {
                    exportBlock += (exportBlock ? '\n' : '') + "exports." + specifier.reexported + " = " + name + "." + specifier.imported + ";";
                }
                else if (specifier.reexported !== '*') {
                    exportBlock += (exportBlock ? '\n' : '') + "exports." + specifier.reexported + " = " + name + ";";
                }
            });
        }
    });
    exports.forEach(function (expt) {
        var lhs = "exports." + expt.exported;
        var rhs = expt.local;
        if (lhs === rhs) {
            return;
        }
        if (exportBlock) {
            exportBlock += '\n';
        }
        exportBlock += lhs + " = " + rhs + ";";
    });
    return exportBlock;
}
exports.default = getExportBlock;
