"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getGlobalNameMaker(globals, graph, fallback) {
    if (fallback === void 0) { fallback = null; }
    var fn = typeof globals === 'function' ? globals : function (id) { return globals[id]; };
    return function (dependency) {
        var name = fn(dependency.id);
        if (name)
            return name;
        if (dependency.exportsDefault || dependency.exportsNames || dependency.exportsNamespace) {
            graph.warn({
                code: 'MISSING_GLOBAL_NAME',
                source: module.id,
                guess: dependency.name,
                message: "No name was provided for external module '" + module.id + "' in options.globals \u2013 guessing '" + dependency.name + "'"
            });
            return dependency.name;
        }
        return fallback;
    };
}
exports.default = getGlobalNameMaker;
