"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function getInteropBlock(dependencies, options, varOrConst) {
    return dependencies
        .map(function (_a) {
        var name = _a.name, exportsNamespace = _a.exportsNamespace, exportsNames = _a.exportsNames, exportsDefault = _a.exportsDefault;
        if (!exportsDefault || options.interop === false)
            return null;
        if (exportsNamespace)
            return varOrConst + " " + name + "__default = " + name + "['default'];";
        if (exportsNames)
            return varOrConst + " " + name + "__default = 'default' in " + name + " ? " + name + "['default'] : " + name + ";";
        return name + " = " + name + " && " + name + ".hasOwnProperty('default') ? " + name + "['default'] : " + name + ";";
    })
        .filter(Boolean)
        .join('\n');
}
exports.default = getInteropBlock;
